/*
 * Scattercom.java
 *
 * Created on April 1, 2007, 9:27 AM
 */

import java.io.IOException;
import javax.microedition.io.Datagram;
import javax.microedition.io.UDPDatagramConnection;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

/**
 *
 * @author  Sreejith
 * @version
 */
public class Scattercom extends MIDlet implements CommandListener ,SubsystemInvoker {
    
    public static Scattercom instance;
    Form profile=new Form("Scattercom");
    static ProfileInfo profileinfo=new ProfileInfo();
    EditProfile editprofile;
    Display display;
    public static MessageUI messageui;
    public NetLayer btnet;
    ContactSearch csi;
    FileSearch fsi;
    RemoteProfile rprofile=new RemoteProfile();;
    static MyScrapResults myscrapresults;
    
    private Font font;
    
    //ProfileRecordStore prs = new ProfileRecordStore();
    
    Command edit = new Command("Edit Profile", Command.OK, 1);
    Command log = new Command("Log Info", Command.SCREEN, 2);
    Command scattercom = new Command("Scattercom", Command.SCREEN, 2);
    Command viewprofile = new Command("View Profile", Command.SCREEN, 2);
    Command exit = new Command("Back", Command.EXIT, 1);
    Command contactSearch  = new Command("Contact Search",Command.SCREEN,3);
    Command fileSearch  = new Command("File Search",Command.SCREEN,4);
    Command scrap=new Command("My Scrap Book",Command.SCREEN,5);
    
    public Scattercom()
    {
        this.instance=this;
    }
    public void startApp() {
        
        display = Display.getDisplay(this); 
        csi = new ContactSearch(display);
        csi.retrieveContacts();
        
        fsi = new FileSearch(display);
        try
        {
            fsi.addHash();
        }
        catch (SecurityException e) 
        {} 
        catch (Exception e)
        {}
        btnet= new NetLayer(display);
        messageui = new MessageUI(btnet,display);
        btnet.init( this );
        myscrapresults=new MyScrapResults(display);
        profile.addCommand(edit);
        profile.addCommand(log);
        profile.addCommand(exit);
        profile.addCommand(viewprofile);
        profile.addCommand(scattercom);
        profile.addCommand(contactSearch);
        profile.addCommand(fileSearch);
        profile.addCommand(scrap);
        profile.setCommandListener(this);
        profileinfo.prs.InitializeProfile();
        setprofile();
        
    }
    public void setprofile()
    {   
        profileinfo.addInfo("","","","","");
        profile.deleteAll();
        StringItem name = new StringItem("Name",AddSpace(profileinfo.name));
        StringItem address = new StringItem("Address",AddSpace(profileinfo.address));
        StringItem number = new StringItem("Mobile Number",AddSpace(profileinfo.number));
        StringItem dob = new StringItem("Date of Birth",AddSpace(profileinfo.dob));
        StringItem sex = new StringItem("(M)ale or (F)emale",AddSpace(profileinfo.sex));
        
        profile.append(name);
        profile.append("\n");
        profile.append(address);
        profile.append("\n");
        profile.append(number);
        profile.append("\n");
        profile.append(dob);
        profile.append("\n");
        profile.append(sex);
        display.setCurrent(profile);
        
        
    }
    
    public String AddSpace ( String temp) {
        int width;
      try {  width = font.stringWidth(temp);
        for(int i = 0 ; i < 225 - width ; i++) {
            temp = temp + ' ';
        }
      }
      catch (Exception e) {
          System.out.println("Error in add space " + e.toString());
      }
        return temp;
    }
    
    public void pauseApp() {
    }
    
    public void destroyApp(boolean unconditional) {
        
        log( "invoke destroyApp()");
        btnet.disconnect();
        instance.notifyDestroyed();
        instance = null;
        display = null;
        
        
    }
    public static void log( String s)
    {
         System.out.println("Main: "+s);
         Scattercom.instance.gui_log( "M", s );
    }

    public static void gui_log(String source, String s)
    {
        Packet packet = new Packet(NetLayer.SIGNAL_MESSAGE, source,  s );
        instance.messageui.msgs.addElement(packet);
        instance.messageui.repaint();
     }

    public void handleAction(String event, Object param1, Object param2) {
                
        log("invoke handleAction. action="+event);
        if ( event.equals( SubsystemInvoker.EVENT_MESSAGE) )
        {
             
            EndPoint endpt = (EndPoint) param1;
            Packet packet = (Packet) param2;
            Packet displaypacket = new Packet(NetLayer.SIGNAL_MESSAGE, btnet.nodes.getName(packet.sender), packet.msg );
            messageui.msgs.addElement( displaypacket );
            messageui.repaint();
            

        }
         if ( event.equals( SubsystemInvoker.EVENT_PROFILE) )
        {
             
            EndPoint endpt = (EndPoint) param1;
            Packet packet = (Packet) param2;
            Packet displaypacket = new Packet(NetLayer.SIGNAL_PROFILE, btnet.nodes.getName(packet.sender), packet.msg );
            messageui.msgs.addElement( displaypacket );
            messageui.repaint();
            rprofile.update(packet.msg);
            rprofile.bluetoothaddr=packet.sender;
            display.setCurrent(rprofile.remoteprofile);
         } 
          if ( event.equals( SubsystemInvoker.EVENT_SCRAP) )
          {
                Display.getDisplay(this).flashBacklight(2000);
                Display.getDisplay(this).vibrate(1000);
          }
    }

    public void commandAction(Command c, Displayable displayable) {
          
        if (c.getLabel().equals("Edit Profile"))
        {
                System.out.println("edit profile");
               editprofile=new EditProfile(display,instance);
               editprofile.setdisplay();
        }
        else if (c ==exit) {
            
            destroyApp(true);
            notifyDestroyed();
            
        }
        else if (c==log){
            display.setCurrent(messageui);
        }
        else if (c==scattercom){
            
            btnet.query();
        }
        else if (c==viewprofile)
        {
            btnet.sendUI(NetLayer.SIGNAL_VIEW_PROFILE);
        }
        else if(c == contactSearch)
        {
            //ContactSearch cs = new ContactSearch(display);
            csi.startContactSearch();
        }
        else if(c == fileSearch)
        {
            //FileSearch fs = new FileSearch(display);
            fsi.startFileSearch();
        }
        else if(c==scrap)
        {
            myscrapresults.setResultsDisplay(false,btnet.localName+"'s Profile");
            myscrapresults.AddScrap2Vector(myscrapresults.msrs.TheMessage);
        }
    
    }
}
