import java.io.*;

public class Sender implements  Runnable{
    public EndPoint endpt;
    private boolean done=false;
    public Sender(){
        
    }
    public void stop(){
        done=true;
    }
    public void run(){
        try
        {
             DataOutputStream dataout = endpt.con.openDataOutputStream();
             while( !done )
             {
                    if(!endpt.peekString())
                    {
                        synchronized (this){
                        this.wait(5000);}                                          
                    }
                    Packet s = endpt.getString();
                     if ( s != null && (s.signal == NetLayer.SIGNAL_MESSAGE ||s.signal == NetLayer.SIGNAL_VIEW_PROFILE||s.signal==NetLayer.SIGNAL_PROFILE
                            || s.signal==NetLayer.SIGNAL_SCRAP_RESPONSE||s.signal==NetLayer.SIGNAL_SUBMIT_SCRAP||s.signal==NetLayer.SIGNAL_CONTACTS_NAME_REQUEST
                            || s.signal==NetLayer.SIGNAL_CONTACTS_NUM_REQUEST||s.signal==NetLayer.SIGNAL_CONTACTS_RESPONSE||s.signal==NetLayer.SIGNAL_FILE_SEARCH_REQUEST
                            || s.signal==NetLayer.SIGNAL_FILE_SEARCH_RESPONSE))
                     {       
                            log("sending signal "+s.signal+" string "+s.msg+"Sender"+s.sender+" to "+s.destination);
                            dataout.writeInt(s.signal);
                            dataout.flush();
                            dataout.writeUTF(s.msg );
                            dataout.flush();
                            dataout.writeUTF(s.sender );
                            dataout.flush();
                            dataout.writeUTF(s.destination);
                            dataout.flush();
                     }
                     else if( s != null )
                    {       log("sending signal "+s.signal+" string '"+s.msg+"' to "+endpt.remotebtaddr);
                            dataout.writeInt(s.signal);
                            dataout.writeUTF(s.msg );
                            dataout.flush();
                     }
                    if ( s != null && s.signal == NetLayer.SIGNAL_TERMINATE )
                    {
                          stop();
                    } 
                    
             }
             dataout.close();
        }
        catch (Exception e)
        {
            e.printStackTrace();
            log(e.getClass().getName()+" "+e.getMessage());
            log("device disconnected");
        }
        log("sender thread exit for "+endpt.remotebtaddr);

    }
    
    private static void log( String s)
    {
        // "S" means Sender class
        Scattercom.instance.gui_log( "S", s );
    }
       
          
}
